/***************************************************************************
                          settings.h  -  description
                             -------------------
    begin                : December 2007
    copyright            : (c) 2007 by Roland Suchan
    email                : vmp@arcor.de
    license              : GPL v 2.0
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of QTrans.                                          *
 *                                                                         *
 *   QTrans is free software; you can redistribute it and/or modify        *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License.               *
 *                                                                         *
 *   QTrans is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with QTrans. If not, see <http://www.gnu.org/licenses/> or      *
 *   write to the Free Software Foundation, Inc.,                          *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.         *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGS_H
#define SETTINGS_H

#include <KPageDialog>
#include <KColorButton>
#include <QCheckBox>
#include <QLabel>
#include <KComboBox>
#include <KFontChooser>

#include <QAction>

#include "qtrans.h"
#include "settings_widg.h"
#include "systemtray.h"

class Settings : public KPageDialog   //ooo
{
    Q_OBJECT

public:
	//Settings( QTrans* parent = 0, const char* name = 0, bool modal = FALSE, Qt::WFlags fl = 0);
	Settings(QTrans *parent = 0);
	~Settings();

	//KFontChooser * dFont;
	KFontChooser *chooseFont;

	QCheckBox* AutoPop;
	QCheckBox* DontClose;
	QCheckBox* DockIcon;
	QCheckBox* StartMin;
	QCheckBox* hideTask;
	QCheckBox* mouseSelection;	//ooo
	QCheckBox* StatusBar;		//ooo

	QCheckBox* EnableShortCut;
	KComboBox* Char;
	KComboBox* Charset;
	KComboBox* widgetStyle;	//ooo
	QLabel* TextLabel3;
	QLabel* TextLabel4;
	QLabel* TextLabel5;	//ooo

	KColorButton *colorBtBack;
	KColorButton *colorBtText;
	KColorButton *colorBtExpressionText;	//ooo
	KColorButton *colorBtSentencePartText;	//ooo

	QTrans* Par;
	Settings_widg *Bab;

//	QList<QAction*> actionsList;
//	QActionGroup *languageGroup;
	KActionCollection *actionCollection();

public slots:
	void slot_close();
	void slot_Ok();
	int slot_apply();
	void slot_DockIcon();
};


#endif
